// *************************************************************************
//    Compile.h
// *************************************************************************

#ifndef _Compile_H_
#define _Compile_H_

#include "Table.h"
#include "ModulePred.h"
#include "Debug.h"

// *************************************************************************

class Cor_ParserStruct;
class Cor_RuleInfoArray;
class Cor_SemiNaive;
class Cor_QFModuleData;
class Cor_Predicate;
class Cor_Scc;
class Cor_SccInfo;

// *************************************************************************

int Cor_get_offset(Cor_Table *F, Cor_CArg& name, int arity, int print_error=1);
int Cor_get_offset(Cor_Table *F, Cor_Literal *pred, int print_error = 1);

void Cor_compile_single_rule(Cor_ParserStruct *Cor_parserStruct,
    Cor_Table* &module_table, Cor_RuleInfoArray* &module_rules,
    Cor_SemiNaive &snrule);

void Cor_interpret_module(Cor_ParserStruct *Cor_parserStruct);

int Cor_determine_subsum_status(Cor_QFModuleData *md, Cor_CArg& name,
        int default_val);
void Cor_get_annos(Cor_QFModuleData *md, Cor_ModulePred *predicate);

int Cor_Find_RMark_Offset(Cor_SccInfo *scc_info, Cor_Predicate *rpred);

int Cor_has_fail_in_body(Cor_Clause *rule);

void Cor_add_pred_extern(Cor_Predicate *pred, PredKind kind,
            Cor_ModulePred *predicates);

void Cor_initialize_scc_structs();
void Cor_clear_scc_list();

int Cor_find_predicates_invoked_from(Cor_Predicate *pred, int original = 0);
void Cor_number_sccs(Cor_Scc *Sccs);

// *************************************************************************

#endif _Compile_H_
