// *************************************************************************
//    CompileRule.h
// *************************************************************************

#ifndef _CompileRule_H_
#define _CompileRule_H_

#include "RuleInfo.h"
#include "Rule.h"
#include "Debug.h"

// *************************************************************************

class Cor_Literal;
class Cor_PredAnnotations;
class Cor_Table;
class Cor_SemiNaive;

// *************************************************************************

void Cor_create_an_annotation(Cor_PredAnnotations *&annos, Cor_Literal *lit,
    Cor_IntStack *var_list);

Cor_IntStack *Cor_vars_between(Cor_Clause *adrule, int start, int end,
    Cor_IntStack *var_stk, int *predOrders = NULL);

int Cor_is_a_builtin(Cor_CArg& name);

Cor_RuleInfo *Cor_create_rule_info(Cor_Table *F, Cor_Clause *rule);

void Cor_compile_nonrec_rule(Cor_SemiNaive &sn, Cor_Clause *clause,
    Cor_RuleInfo *rInfo);

void Cor_generateIndexes(Cor_SemiNaive *snrule, Cor_PredAnnotations *&annos);
void Cor_initPredOrders(Cor_SemiNaive *sn);

int  initFailureBacktrack(Cor_SemiNaive *sn);

// *************************************************************************

#endif _CompileRule_H_
