//*********************************************************************
//    Identify.h
//
//    Including this file will define HPUX, SUN, MIPS,
//    SOLAR, SOLAR_386, or OTHER. 
//    
//    (should probably contain VMS and some others)
//
//*********************************************************************

#ifndef    _Identify_H
#define    _Identify_H

// HPUX - 

#ifdef  _HPUX_SOURCE
#    define    HPUX
#endif

//*********************************************************************

// SOLARIS 

#ifdef    __svr4__
#    ifdef    i386
#        define    SOLAR_386
#    else
#        define    SOLAR
#    endif

#else

#    ifdef    sparc
#        define    SUN
#    endif

#endif

//*********************************************************************

// MIPS - 

#ifdef    __MIPSEL
#    define    MIPS
#endif

//*********************************************************************

// Linux

#ifdef    __linux
#    define    LINUX
#endif

//*********************************************************************

// Catch all for others

#if !defined(HPUX) && !defined(SUN) && !defined(MIPS) && !defined(LINUX) \
        && !defined(SOLAR) && !defined(SOLAR_386)
#    define    OTHER
#    ifdef     DEBUG
#    error     "System Architecture not one of the predefined types"
#    endif     DEBUG
#endif 


/*
// For testing if the above is working (for a single case).
#ifdef    HPUX
#error    "HPUX _is_ defined"
#else
#error    "HPUX _is not_ defined"
#endif
*/

//*********************************************************************

#endif     // _Identify_H
