// *************************************************************************
//    Operators.h
// *************************************************************************

#ifndef _Operators_H_
#define _Operators_H_

// *************************************************************************

class Cor_Relation;
class Cor_Term;
class Cor_BuiltinRelation;
class Cor_TupleIterator;
class Cor_BindEnv;
class Cor_CArg;

#include "Tuple.h"

// *************************************************************************

Cor_Tuple *Cor_FuncOp(Cor_Tuple *query);
Cor_Tuple *Cor_ArgOp(Cor_Tuple *query);
void Cor_AddOp(Cor_CArg& carg, const Cor_CArg& arg0, const Cor_CArg& arg1);
void Cor_SubOp(Cor_CArg&, const Cor_CArg& arg0, const Cor_CArg& arg1);
void Cor_MulOp(Cor_CArg& carg, const Cor_CArg& arg0, const Cor_CArg& arg1);
void Cor_DivOp(Cor_CArg& carg, const Cor_CArg& arg0, const Cor_CArg& arg1);

void Cor_SumOp(Cor_CArg& carg, Cor_Relation *rel);
void Cor_ProdOp(Cor_CArg& carg, Cor_Relation *rel);
void Cor_AvgOp(Cor_CArg& carg, Cor_Relation *rel);
void Cor_StdDevOp(Cor_CArg& carg, Cor_Relation *rel);
void Cor_CountOp(Cor_CArg& carg, Cor_Relation *rel);

void Cor_MinOp(Cor_CArg& carg, Cor_Relation *rel);
void Cor_MaxOp(Cor_CArg& carg, Cor_Relation *rel);

int Cor_EquOp(Cor_Term& term0, Cor_Term& term1);
int Cor_NeqOp(Cor_Term& term0, Cor_Term& term1);
int Cor_LssOp(Cor_Term& term0, Cor_Term& term1);
int Cor_GrtOp(Cor_Term& term0, Cor_Term& term1);
int Cor_LeqOp(Cor_Term& term0, Cor_Term& term1);
int Cor_GeqOp(Cor_Term& term0, Cor_Term& term1);

void Cor_LShiftOp(Cor_CArg& carg, const Cor_CArg& arg0, const Cor_CArg& arg1);
void Cor_RShiftOp(Cor_CArg& carg, const Cor_CArg& arg0, const Cor_CArg& arg1);
void Cor_BitorOp(Cor_CArg& carg, const Cor_CArg& arg0, const Cor_CArg& arg1);
void Cor_BitandOp(Cor_CArg& carg, const Cor_CArg& arg0, const Cor_CArg& arg1);
void Cor_BitxorOp(Cor_CArg& carg, const Cor_CArg& arg0, const Cor_CArg& arg1);
void Cor_ModOp(Cor_CArg& carg, const Cor_CArg& arg0, const Cor_CArg& arg1);

// *************************************************************************

#endif _Operators_H_
