#ifdef URL_REL

// *************************************************************************
//    UrlRelation.h
// *************************************************************************

#ifndef _UrlRelation_H_
#define _UrlRelation_H_

#include "StorageRelation.h"
#include "RelationList.h"
#include "Debug.h"
#include "Config.h"

#include <strstream.h>

#define MAX_URL_LEN 100

class Cor_UrlRelation : public Cor_StorageRelation {
private:
    char _local_name[COR_MAX_REL_NAME_LEN];
    char _url[MAX_URL_LEN];
    char _relation_name[COR_MAX_REL_NAME_LEN];
    int _arity;
    
    int valid;

    char result[10000]; // ??????
    istrstream* ist;
    
    Cor_Tuple * GetNext();
    
    void Cor_UrlRelation::Init(Cor_TupleIterator& iterator);
    Cor_Tuple * Cor_UrlRelation::Done(Cor_TupleIterator& iterator);
    
public:

    Cor_UrlRelation(char * ln, int arity, char * url, char * rn);
    
    ~Cor_UrlRelation();

    int Valid() {return valid;}
    
    virtual int insert_tuple(Cor_Tuple *tuple);
    
    virtual Cor_BindEnv *get_next(Cor_TupleIterator&); 
    virtual Cor_Tuple *get_next_tuple( Cor_TupleIterator& it) ;

    virtual void release(Cor_TupleIterator& it) ;

    // Empty tuples out of the relation.  Delete the tuples
    // only if the deleteTuples arg is not 0
    virtual void empty_relation(int deleteTuples = 0);

    virtual int tuple_delete(Cor_Tuple *tuple);
    
    virtual void print_name(ostream *out);

};

int open_http( const char *name, int * bytes_in_body);
void http_url(char * url);

// *************************************************************************

#endif _UrlRelation_H_

#endif // URL_REL
