
/*
 * Example of the use of open_scan() function.
 */

#include <iostream.h>

int main(int argc, char **argv)
{

    cout << "scan1.S: Demonstrating open_scan().\n";

    init_coral(argv[0]);
  
    \[
      clear(interactive_mode).
    \]

    /* First consult the data file which contains facts of the
     * form data(1,2), data(2,3), etc.
     */
    \[
      consult("data.F").
    \]

    Cor_ScanDesc *scan = open_scan("data(X,Y).");

    Cor_Tuple *tuple = NULL;
    int sum = 0;

      /* Iterate over the tuples in the relation */
    for (tuple = scan->next_tuple(); !(scan->no_match());
                     tuple = scan->next_tuple()) {
      if (!is_int((*tuple)[0])) {
        cerr << "Error: non-integer first field!\n";
        exit(1);
      }
      sum += make_int((*tuple)[0]);
    }

    cout << "Sum is " << sum << endl;
    exit_coral();

    return(0);
}

