#ifndef _RDBINSERT_H_
#define _RDBINSERT_H_

#include "RdbCompilableDML.h"
#include "RdbRelation.h"
#include "RdbItem.h"
#include "String.h"


class RdbInsert
: public RdbCompilableDML
{
  public:  

    RdbInsert(RdbRelation& newRel); // setup an insert in this relation

    virtual ~RdbInsert();

    ErrorCode Insert(const RdbItemList& newTuple);
				// insert this tuple into the relation

  protected:

    RdbRelation& rel;		// the relation to insert into

//    void CreateStmt(const String varPlaceHolder = String("?"),
    void CreateStmt(const String varPlaceHolder = questionMark,
		    const int addSequence = 0);
				// create the ansi std. sql insert statement
				// with variables marked with varPlaceHolder
				// followed by a sequence number if requested.

    void CreateStmt(const RdbItemList& bindings);
				// create the ansi std. sql insert statement
				// with the specified bindings.

    virtual ErrorCode VInsert(const RdbItemList& newTuple) = 0;

  private:

    RdbInsert(const RdbInsert&); // na

    RdbInsert& operator =(const RdbInsert&); // na
};

#include "RdbInsert.i"

#endif // _RDBINSERT_H_
