
#include "Rdb.h"

void PrintAll( RdbQuery& query, RdbItem& bindit )
{
    RdbItemList bindings, result;
    bindings.Append( bindit );
    RdbCursor csr( query, bindings );
    int row = 0;
    while( !csr.GetNext( result ) ) {
	cout << ++row << ": ";
	for( int i = 0 ; i < result.Size() ; i++ )
	  cout << result[i] << ' ';
	cout << '\n';
    }
    cout << "done w/ PrintAll\n";
}


void PrintAll( RdbQuery& query )
{
    RdbItemList bindings, result;
    RdbCursor csr( query, bindings );
    int row = 0;
    while( !csr.GetNext( result ) ) {
	cout << ++row << ": ";
	for( int i = 0 ; i < result.Size() ; i++ )
	  cout << result[i] << ' ';
	cout << '\n';
    }
    cout << "done w/ PrintAll\n";
}


main()
{
    cout << "Starting...\n";
    for( int i = 2 ;  i ; i-- ) {
	RdbManager mgr;
#ifdef DO_SYBASE
	RdbSystem& sys = *mgr.LookupSystem("sybase");
	RdbDatabase& test = *sys.OpenDatabase("beyer","beyer","mar");
#endif
#ifdef DO_INGRES
	RdbSystem& sys = *mgr.LookupSystem("ingres");
	RdbDatabase& test = *sys.OpenDatabase("test");
#endif
	BitVector bv(3), bv2(3);
	bv.set(1); 
	bv2.set(2);
	test.Connect();
	{
	    RdbColNameList cols;
	    cols.Append(String("id")); cols.Append(String("name")); 
	    cols.Append(String("sal"));
	    RdbRelation rel1( test, "prof", cols );

	    RdbRelList relList1;
	    relList1.Append(&rel1);
	    RdbRelList relList2;
	    relList2.Append(&rel1); relList2.Append(&rel1);

	    RdbJoinCondList joinCondList1;
	    RdbJoinCondList joinCondList2;
	    RdbJoinCondition joinCond(0,2,1,2);
	    joinCondList2.Append(joinCond);
	    RdbJoin join1(relList1,joinCondList1);
	    RdbJoin join2(relList2,joinCondList2);

	    BitVector bv0(6);

	    RdbQuery& q1 = *test.NewQuery(join1, bv);
	    //cout << test.GetErrorMessage();
	    String s =  test.GetErrorMessage();
	    cout << s;
	    RdbQuery& q2 = *test.NewQuery(join1, bv2);

	    RdbQuery& q3 = *test.NewQuery(join2, bv0);


	    cout << test.GetErrorMessage();

	    PrintAll(q3);

	    PrintAll( q1, RdbItem("raghu") );
	    PrintAll( q1, RdbItem("dewitt") );
	    PrintAll( q2, RdbItem(9000) );
	    PrintAll( q2, RdbItem(10000) );
	    PrintAll( q2, RdbItem(2) );
	    PrintAll( q1, RdbItem("raghu") );
	    PrintAll( q1, RdbItem("kevin") );
	    PrintAll( q2, RdbItem(1) );
	    PrintAll( q2, RdbItem(9000) );
	    PrintAll( q1, RdbItem("raghu") );

	    PrintAll(q3);

	    RdbInsert& insert = *test.NewInsert(rel1);
	    RdbItemList insertList;
	    insertList.Append(RdbItem(100));
	    insertList.Append(RdbItem("mary"));
	    insertList.Append(RdbItem(9000.0));
	    cout<<"insert rc "<<(int)insert.Insert(insertList)<<'\n';
	    insertList.DeleteAll();
	    insertList.Append(RdbItem(101));
	    insertList.Append(RdbItem("margaret"));
	    insertList.Append(RdbItem(9000.0));
	    cout<<"insert rc "<<(int)insert.Insert(insertList)<<'\n';

	    delete &q1;
	    delete &q2;
	    delete &q3;
	    
	}
	test.Disconnect();
    }
    cout << "\nThat's all folks!\n";
}


