// *************************************************************************
//    BuiltinCompareRelation.C
// *************************************************************************

#include "BuiltinCompareRelation.h"

#include "TupleIterator.h"
#include "InitBuiltins.h"
#include "Globals.h"
#include "Debug.h"

// *************************************************************************
Cor_BuiltinCompareRelation::Cor_BuiltinCompareRelation(int a, Cor_CArg *n,
    CompareProc c_op) : Cor_BuiltinRelation(a, n, NULL)
{
#ifdef    DO_CALL_STACK
    CallStk_Mark    callstk_mark(__FUNCTION__,__FILE__,__LINE__);
#endif
    op = c_op;
}

/*****************************************************************************/
Cor_BindEnv *Cor_BuiltinCompareRelation::get_next(Cor_TupleIterator& iterator)
{
#ifdef    DO_CALL_STACK
    CallStk_Mark    callstk_mark(__FUNCTION__,__FILE__,__LINE__);
#endif
    Cor_BindEnv *env = iterator.bindenv;

    if (iterator.ipos > 0) {
        iterator.stack_mark.pop_to();
        iterator.set_no_match();
        return env; 
    }
    iterator.ipos++;
    iterator.stack_mark.get_mark();

    for (int i = 0; i < 2; i++) {
        Cor_static_terms[i].expr = iterator.arg_list[i],
            Cor_static_terms[i].bindenv = env;
        Cor_full_dereference_term(Cor_static_terms[i]);
    }
    
    if (!(*op)(Cor_static_terms[0], Cor_static_terms[1]))
        iterator.set_no_match();

    if (iterator.no_match())
        iterator.stack_mark.pop_to();
    return (env);
}

/*****************************************************************************/

