// *************************************************************************
//    DerivedRelation.h
// *************************************************************************

#ifndef _DerivedRelation_H_
#define _DerivedRelation_H_

#include "Relation.h"
#include "DerivedMethod.h"
#include "Debug.h"

// *************************************************************************

class Cor_DerivedRelation : public Cor_Relation {

  public:
    Cor_DerivedMethod *methods;

    Cor_DerivedRelation(Cor_CArg& name, int arity);
    Cor_DerivedRelation() { }
    virtual ~Cor_DerivedRelation();

    virtual Cor_BindEnv *get_next(Cor_TupleIterator&);
    virtual Cor_Tuple  *get_next_tuple(Cor_TupleIterator& it);

    virtual void release(Cor_TupleIterator&);
    virtual void print_name(ostream *file);
    virtual void print_facts(ostream *file,
            Cor_ArgList *arglist = NULL) const;
    virtual int insert_new(Cor_ArgList& args, Cor_BindEnv *env);
    virtual int insert_tuple(Cor_Tuple *tuple){
        return insert_new(tuple->args(), NULL);
    }
};

// *************************************************************************

int Cor_andOptionToRelation(Cor_Relation *rel, char *adorn_form,
        RelationOptions Cor_opt);
int Cor_orOptionToRelation(Cor_Relation *rel, char *adorn_form,
        RelationOptions Cor_opt);

// *************************************************************************

#endif _DerivedRelation_H_
