// *************************************************************************
//    RuleEnv.h
// *************************************************************************

#ifndef _RuleEnv_H_
#define _RuleEnv_H_

#include "SemiNaive.h"
#include "BindEnv.h"
#include "StackMark.h"
#include "ArgList.h"
#include "Tuple.h"
#include "BindEnv.h"

// *************************************************************************

class Cor_TupleIterator;

// *************************************************************************
//  Holds run time data structures for SemiNaive that need to be allocated
//  at every module invocation

class Cor_RuleEnv {

  public:
    int                 max_literals;    // needed for destructor
    Cor_SemiNaive      *parent_sn;
    Cor_BindEnv         bindenv;
    Cor_StackMark      *rmarks;
    Cor_TupleIterator **tuple_its;
    Cor_ArgList       **arglist_its;
    Cor_Tuple         **tuples;
    Cor_BindEnv       **bindenvs; // For use by ReturnUnify code

    Cor_RuleEnv(Cor_SemiNaive *parent);
   ~Cor_RuleEnv();

    void clear_tupits();
};

// *************************************************************************

#endif _RuleEnv_H_
