// **************************************************************************
//    hsr.C
// **************************************************************************

#include <stddef.h>
#include <stdio.h>
#include <string.h>
#include <unistd.h>
#include <iostream.h>

#include "CoralInit.h"
#include "Globals.h"
#include "ParseStack.h"
#include "CoralError.h"
#include "Util.h"
#include "BuiltinUtil.h"

#include "LocalConnectArray.h"
#include "Debug.h"

#include "Interface.h"

// *************************************************************************
// *************************************************************************

// Special includes needed just for the tests
#include "CArg.h"


// *************************************************************************
 // You can do whatever you like inside here, it is called once.

void run_test()
{
    Cor_CArg   l1, l2, l3, l4, l5;
    Cor_CArg  *p1, *p2, *p3;
    Cor_CArg  *a1, *a2, *a3, *a4, *a5;

/*
    l1 = 1;
    l2 = 2;
    l3 = 3;
    l4 = 4;
    l5 = 5;
*/

    a1 = new Cor_CArg(1);
    a2 = new Cor_CArg(2);
    a3 = new Cor_CArg(3);
    a4 = new Cor_CArg(4);
    a5 = new Cor_CArg(5);

    p1 = make_list(5, a1, a2, a3, a4, a5);
    /*  p1 = make_list(5, &l1, &l2, &l3, &l4, &l5);  */
    l1 = *p1;

    cout << "List p1: " << *p1 << "  and l1: " << l1 << endl;

    p2 = p1->cdr();
    l2 = *p2;

    cout << "List p1: " << *p1 << "  and l1: " << l1 << endl;
    delete p1;

    cout << "List p2: " << *p2 << "  and l2: " << l2 << endl;
    
    p3 = p2->cdr();
    l3 = *p3;

    delete p3;

    cout << "List p2: " << *p2 << "  and l2: " << l2 << endl;

    p3 = p2->cdr();
    l1 = *p3;
    cout << "List p3: " << *p3 << "  and l3: " << l3 << endl;

    delete p2;
    delete p3;

/*  delete a1;
    delete a2;
    delete a3;
    delete a4;
    delete a5;
*/
}

// *************************************************************************
// *************************************************************************
// You should never need change main()
int main(int ac, char **av)
{
      // We need these right away
    Cor_new_globals();

      // Start up a "Local" Connection (use cin_strm/cout_strm)
    Cor_clients = new Cor_LocalConnectArray();

    Cor_exEnv->C_interactive_mode_default = 0;
    Cor_exEnv->C_exec_mode = COR_DOING_INTERPRET;

    init_coral(av[0]);
    init_coral_interactive();

    // *********************************

    cout << "\nCalling run_test()\n";

    run_test();

    cout << "Done calling run_test()\n";

    // *********************************
    
    if (!Cor_exEnv->C_quiet_mode_default) {
        cerr << "\nHave a good day, " << cuserid(NULL) << "!\n";
    }

    exit_coral();
    return(0);
}

//**************************************************************************
