// *************************************************************************
//    BPlusTreeIndex.h
// *************************************************************************

#ifndef _BPlusTreeIndex_H_
#define _BPlusTreeIndex_H_

#include "IndexStruct.h"
#include "Config.h"
#include "Debug.h"

// *************************************************************************

class Cor_BPlusTreeIndex : public Cor_IndexStruct {
public:
    IID    iid;                            // Index id
    char attrs[COR_MAX_ARGLIST_SIZE];    // Specifies which attributes the index
                    // is on. A non-zero value of an entry
                    // implies that the index is based on
                    // the corresponding attribute of the
                    // relation

    virtual void operator=(Cor_BPlusTreeIndex& index2)
    {
        for (int i = 0; i < COR_MAX_ARGLIST_SIZE; i++ )
            attrs[i] = index2.attrs[i];
        iid = index2.iid;
        arity = index2.arity;
    }

    virtual PersIndexKind kindof() { return COR_BPLUSTREE; };
    virtual int    valid() { return !(IID_IS_INVALID(iid));};
    Cor_BPlusTreeIndex();
    virtual void create(Cor_BitVector *, int arity, int unique);
    virtual void insert(USERDESC *u_desc, Cor_Schema&);
    virtual int matches(char *attr_str, int arity);
    virtual void delete_entry(USERDESC *u_desc, Cor_Schema&);
    virtual void destroy();
    virtual void Cor_print_adornment(ostream *outf);
    virtual int begin_load();
    virtual int end_load();
    virtual int abort_load();
};

// *************************************************************************

#endif _BPlusTreeIndex_H_
